searchNodes=[{"doc":"Used to interact with Honeycomb's API for sending events.InstallationAdding Honeylixir to your mix.exs as a dependency should suffice for installation:def deps() do [ {:honeylixir, &quot;~&gt; 0.5.0&quot;} ] endConfigurationYou can configure any of the following variables via Config:NameTypeDescriptionDefault:api_hoststringAPI to send events tohttps://api.honeycomb.io:sample_rateintegerDefault rate at which events will be sampled represented as a percented. e.g., use 10 to send 10% of events1:sample_hookfunction/2Arity 2 function accepting the sample rate originally on the event and all fields at the time of sending as the secondN/A:team_writekeystringAPI key used to send eventsnil:datasetstring/atomDataset to send the events tonil:service_namestring/atomName of your service which will be added as a field on all events at the key &quot;service_name&quot;nil:max_queue_sizeintegerHow large the transmission queue can grow before events are dropped10_000:batch_sizeintegerHow many events to send per batch50:batch_timingintegerTime in milliseconds to try sending events from the queue in a batch100:max_send_processesintegerHow many Processes to use for sending events in the background30It is required that you set :team_writekey and :dataset for events to be sent. Otherwise, they will return non-200 responses from Honeycomb resulting in the events being dropped. An example config may look like so (whether distillery or compile time Mix):config :honeylixir, dataset: :&quot;my-company&quot;, team_writekey: System.get_env(&quot;HONEYLIXIR_WRITEKEY&quot;), service_name: :my_applicationAdditionally, many are defined on the Honeylixir.Event struct and can be overridden on a per-event basis. Please check its typspec for a complete list of what you can modify.event = Honeylixir.Event.create() event = %{event | api_host: &quot;https://some-other-valid-host.com&quot;}UsageSending eventsHoneylixir provides the ability to make a Honeylixir.Event, add fields to it, then send it off asynchronously.Honeylixir.Event.create() |&gt; Honeylixir.Event.add_field(&quot;a_field&quot;, &quot;my_value&quot;) |&gt; Honeylixir.Event.add_field(&quot;something-else&quot;, %{&quot;nested&quot; =&gt; &quot;value&quot;}) |&gt; Honeylixir.Event.send()Any value that dervices the Jason.Encoder protocol can be used, but fields are REQUIRED to be strings. Non-string fields will result in a no matching function clause error.Global field configurationHoneylixir supports adding global fields which will be added to all events on event creation. You can add, remove, or view the fields configured at any time.Honeylixir.GlobalFields.add_field(&quot;my-thing&quot;, &quot;special&quot;) event = Honeylixir.Event.create() IO.inspect(event.fields) # =&gt; %{&quot;my-thing&quot; =&gt; &quot;special&quot;} IO.inspect Honeylixir.GlobalFields.fields # =&gt; %{&quot;my-thing&quot;, &quot;special&quot;} Honeylixir.GlobalFields.remove_field(&quot;my-thing&quot;) IO.inspect Honeylixir.GlobalFields.fields # =&gt; %{}Configuring SamplingYou can configure a sample_hook that is invoked when an event is sent. This is called first to determine if the event will actually be sent to Honeycomb. The expected way to use this is to pass a function using &amp;Module.function/2 syntax. If you are using pattern matching in your sample hook and aren't covering all cases on your own, you can set the catch-all sample hook to call the default_sample_hook in this package.defmodule MyApp.HoneycombSampling do def sample(original_rate, %{&quot;user_id&quot; =&gt; user_id}) do {Honeylixir.DeterinsticSampler.should_sample?(original_rate, user_id), original_rate} end def sample(original_rate, fields), do: Honeylixir.default_sample_hook(original_rate, fields) end config :honeylixir, sample_hook: &amp;MyApp.HoneycombSampling.sample/2Builder patternCurrently, the Builder pattern is supported insomuch as Elixir's syntax allows it. That is to say, you can create your own function that acts as a Builder.defmodule MyHoneylixirBuilders do def http_event do Honeylixir.Event.create() |&gt; Honeylixir.add_field(&quot;foo&quot;, &quot;bar&quot;) end def different_dataset_event do %{Honeylixir.Event.create() | dataset: &quot;my-other-dataset&quot;} |&gt; Honeylixir.add_field(&quot;something&quot;, &quot;great&quot;) |&gt; Honeylixir.add_field(&quot;another&quot;, &quot;thing&quot;) end endChecking responsesBy attaching metadata to your events, you can pull Honeylixir.Responses to see what happened to your event. These are sent along via :telemetry for getting events as part of the metadata object at the :response field. Current eventNames:[:honeylixir, :event, :send] - Used for the response around any event sent, even if that event is sampled or rejected for queue overflow. Metadata is set to %{response: %Honeylixir.Response} which contains the data.# Note: as stated in the `:telemetry` docs, you should use function capture rather than anonymous functions. :telemetry.attach( &quot;test-attachment&quot;, [:honeylixir, :event, :send], fn _event_name, _measurements, %{response: response}, _config -&gt; IO.inspect response end, nil ) Honeylixir.Event.create() |&gt; Honeylixir.Event.send() # wait for event to async send off and the associated Response will be outputYou can also attach to the function used for key creation::telemetry.attach( &quot;my-listener&quot;, Honeylixir.event_send_telemetry_key(), fn _, _, _, _ -&gt; nil end, nil )","ref":"Honeylixir.html","title":"Honeylixir","type":"module"},{"doc":"Randomly samples your events according to the rate given by generating a random ID for your event which is then used to determine sampling.","ref":"Honeylixir.html#default_sample_hook/2","title":"Honeylixir.default_sample_hook/2","type":"function"},{"doc":"Key used for all event send telemetry executions.","ref":"Honeylixir.html#event_send_telemetry_key/0","title":"Honeylixir.event_send_telemetry_key/0","type":"function"},{"doc":"Generates a random string of 16 bytes encoded in base 16.","ref":"Honeylixir.html#generate_long_id/0","title":"Honeylixir.generate_long_id/0","type":"function"},{"doc":"Generates a random string of 8 bytes encoded in base 16.","ref":"Honeylixir.html#generate_short_id/0","title":"Honeylixir.generate_short_id/0","type":"function"},{"doc":"Function signature required of the function passed as a sample_hook. It takes in the sample rate as it is set on the event in question as well as all the fields that would be sent. The return value should be a tuple of a boolean and integer. The boolean indicates if the event should, in fact, be sent to Honeycomb. The integer is the sample rate as should be reported to Honeycomb for extrapolation.","ref":"Honeylixir.html#t:sample_function/0","title":"Honeylixir.sample_function/0","type":"type"},{"doc":"Provides a helper function for sampling consistently for use in the sample_hook.This code is an Elixir implemenation of the official beeline-ruby one found here: https://github.com/honeycombio/beeline-ruby/blob/v2.4.0/lib/honeycomb/deterministic_sampler.rb","ref":"Honeylixir.DeterminsticSampler.html","title":"Honeylixir.DeterminsticSampler","type":"module"},{"doc":"Determines if this event should be sampled based on the field given. This way, you can deterministically sample given the same value and sample rate with every invocation.Examples iex&gt; Honeylixir.DeterminsticSampler.should_sample?(3, &quot;foo&quot;) true iex&gt; Honeylixir.DeterminsticSampler.should_sample?(3, &quot;bar&quot;) false iex&gt; Honeylixir.DeterminsticSampler.should_sample?(1, &quot;bar&quot;) true iex&gt; Honeylixir.DeterminsticSampler.should_sample?(0, &quot;foo&quot;) false","ref":"Honeylixir.DeterminsticSampler.html#should_sample?/2","title":"Honeylixir.DeterminsticSampler.should_sample?/2","type":"function"},{"doc":"Used for managing Events and holding their data. It also has a send function that really just kicks off the sending process which happens asynchronously.","ref":"Honeylixir.Event.html","title":"Honeylixir.Event","type":"module"},{"doc":"Adds a map of fields into the existing set.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; Honeylixir.Event.add(event, %{&quot;another&quot; =&gt; &quot;field&quot;, &quot;service_name&quot; =&gt; &quot;foobar&quot;}).fields %{&quot;service_name&quot; =&gt; &quot;foobar&quot;, &quot;another&quot; =&gt; &quot;field&quot;}","ref":"Honeylixir.Event.html#add/2","title":"Honeylixir.Event.add/2","type":"function"},{"doc":"Add a single key/value pair to the event.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; Honeylixir.Event.add_field(event, &quot;key&quot;, &quot;other&quot;).fields %{&quot;service_name&quot; =&gt; &quot;honeylixir-tests&quot;, &quot;key&quot; =&gt; &quot;other&quot;}","ref":"Honeylixir.Event.html#add_field/3","title":"Honeylixir.Event.add_field/3","type":"function"},{"doc":"Adds to the metadata of the event.This information is NOT passed along to LaunchDarkly and should only be used by the consuming application to keep track of an event.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; Honeylixir.Event.add_metadata(event, %{&quot;some_key&quot; =&gt; &quot;some_value&quot;}).metadata %{&quot;some_key&quot; =&gt; &quot;some_value&quot;}","ref":"Honeylixir.Event.html#add_metadata/2","title":"Honeylixir.Event.add_metadata/2","type":"function"},{"doc":"Creates an event using the current timestamp, configured values for sending, and no initial fields other than service_name if configured.event = Honeycomb.Event.create()","ref":"Honeylixir.Event.html#create/0","title":"Honeylixir.Event.create/0","type":"function"},{"doc":"create/1 accepts either a timestamp or a set of fields to initialize the Honeylixir.Event.event = Honeylixir.Event.create(&quot;2020-09-29T04:36:15Z&quot;) event = Honeylixir.Event.create(%{&quot;field1&quot; =&gt; &quot;value1&quot;})","ref":"Honeylixir.Event.html#create/1","title":"Honeylixir.Event.create/1","type":"function"},{"doc":"Accepts both a timestamp in ISO8601 format and a map of key/values to initialize the Event struct with.","ref":"Honeylixir.Event.html#create/2","title":"Honeylixir.Event.create/2","type":"function"},{"doc":"Used for acknowledging the event is ready for sending, passing it off to be sent asynchronously. Currently nothing stops a user from sending the same event twice.If the event is sampled, a Honeylixir.Response is sent via :telemetry immediately.","ref":"Honeylixir.Event.html#send/1","title":"Honeylixir.Event.send/1","type":"function"},{"doc":"Storage of the fields for an event. These are stored with String keys pointing to any kind of field so long as it implements the Jason.Encoder protocol.","ref":"Honeylixir.Event.html#t:fields_map/0","title":"Honeylixir.Event.fields_map/0","type":"type"},{"doc":"An ISO8601 formatted timestamp&quot;2020-09-29T04:36:15.123Z&quot;","ref":"Honeylixir.Event.html#t:rfc_timestamp/0","title":"Honeylixir.Event.rfc_timestamp/0","type":"type"},{"doc":"A struct containing all the data of an event.By default, an event is constructed with the values in the configuration defined in Honeylixir. Any field can be overwritten via regular struct assigning of values.event = Honeylixir.Event.create() event = %{event | api_host: &quot;something-else.com&quot;}An Event also includes two other fields:fields - The set of fields which will be sent to Honeycomb as the event bodymetadata - A map of extra data that may be provided as part of a response.","ref":"Honeylixir.Event.html#t:t/0","title":"Honeylixir.Event.t/0","type":"type"},{"doc":"Small Agent used to store and retrieve fields to be added to all events.","ref":"Honeylixir.GlobalFields.html","title":"Honeylixir.GlobalFields","type":"module"},{"doc":"Adds a new key value pair to the global state.","ref":"Honeylixir.GlobalFields.html#add_field/2","title":"Honeylixir.GlobalFields.add_field/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Honeylixir.GlobalFields.html#child_spec/1","title":"Honeylixir.GlobalFields.child_spec/1","type":"function"},{"doc":"Gets all global fields","ref":"Honeylixir.GlobalFields.html#fields/0","title":"Honeylixir.GlobalFields.fields/0","type":"function"},{"doc":"Removes a field from the global state.","ref":"Honeylixir.GlobalFields.html#remove_field/1","title":"Honeylixir.GlobalFields.remove_field/1","type":"function"},{"doc":"Struct and factory functions for generating certain kinds of Responses.","ref":"Honeylixir.Response.html","title":"Honeylixir.Response","type":"module"},{"doc":"Creates a Honeylixir.Response for an event was sent but not accepted by Honeycomb.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; event = %{event | metadata: %{id: 1}} iex&gt; Honeylixir.Response.failure_response(event, 10.2232, 401, &quot;unknown api key&quot;) %Honeylixir.Response{metadata: %{id: 1}, duration: 10.2232, status_code: 401, body: &quot;unknown api key&quot;, err: nil}","ref":"Honeylixir.Response.html#failure_response/4","title":"Honeylixir.Response.failure_response/4","type":"function"},{"doc":"Creates a Honeylixir.Response for an event that was attempted to be sent but failed due to unforeseen HTTP issues, such as a refused connection.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; event = %{event | metadata: %{id: 1}} iex&gt; Honeylixir.Response.http_error_response(event, 10.2232) %Honeylixir.Response{metadata: %{id: 1}, duration: 10.2232, status_code: nil, body: nil, err: :http_error}","ref":"Honeylixir.Response.html#http_error_response/2","title":"Honeylixir.Response.http_error_response/2","type":"function"},{"doc":"Creates a Honeylixir.Response for an event that got dropped due to queue overflow.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; event = %{event | metadata: %{id: 1}} iex&gt; Honeylixir.Response.overflow_response(event) %Honeylixir.Response{metadata: %{id: 1}, duration: 0, status_code: nil, body: nil, err: :overflow}","ref":"Honeylixir.Response.html#overflow_response/1","title":"Honeylixir.Response.overflow_response/1","type":"function"},{"doc":"Creates a Honeylixir.Response for an event that got sampled.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; event = %{event | metadata: %{id: 1}} iex&gt; Honeylixir.Response.sampled_response(event) %Honeylixir.Response{metadata: %{id: 1}, duration: 0, status_code: nil, body: nil, err: :sampled}","ref":"Honeylixir.Response.html#sampled_response/1","title":"Honeylixir.Response.sampled_response/1","type":"function"},{"doc":"Creates a Honeylixir.Response for an event was successfully sent.Examplesiex&gt; event = Honeylixir.Event.create() iex&gt; event = %{event | metadata: %{id: 1}} iex&gt; Honeylixir.Response.success_response(event, 10.2232, 202) %Honeylixir.Response{metadata: %{id: 1}, duration: 10.2232, status_code: 202, body: &quot;&quot;, err: nil}","ref":"Honeylixir.Response.html#success_response/3","title":"Honeylixir.Response.success_response/3","type":"function"},{"doc":"Response object with data about an event after a send attempt.metadata - the metadata from the Event a user can use to correlate this response with a specific eventduration - time in ms it took to send the event, HTTP time only.status_code - status code for this event from Honeycombbody - the body associated with this eventerr - set if an error occurs in sending, such as a max queue size overflow or when the event is sampled","ref":"Honeylixir.Response.html#t:t/0","title":"Honeylixir.Response.t/0","type":"type"},{"doc":"Transmission engine that handles sending events to the expected place.Events have a complicated lifetime from being sent here, possibly sampled out, enqueued, then finally asynchronously sent in a batch. This handles figuring out where it needs to go, sort of like a router and initialy processor for sending events.","ref":"Honeylixir.Transmission.html","title":"Honeylixir.Transmission","type":"module"},{"doc":"Handles sending the batch to a transmission sender task to be processed asynchronously.","ref":"Honeylixir.Transmission.html#send_batch/1","title":"Honeylixir.Transmission.send_batch/1","type":"function"},{"doc":"Queue for processing and managing events to be sent.","ref":"Honeylixir.TransmissionQueue.html","title":"Honeylixir.TransmissionQueue","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Honeylixir.TransmissionQueue.html#child_spec/1","title":"Honeylixir.TransmissionQueue.child_spec/1","type":"function"},{"doc":"Accepts an event and asynchronously adds it to the queue for processing.","ref":"Honeylixir.TransmissionQueue.html#enqueue_event/1","title":"Honeylixir.TransmissionQueue.enqueue_event/1","type":"function"},{"doc":"Synchronously pulls all known queue keys from the state","ref":"Honeylixir.TransmissionQueue.html#get_all_queue_keys/0","title":"Honeylixir.TransmissionQueue.get_all_queue_keys/0","type":"function"},{"doc":"Asynchronously instructs the GenServer to prepare a batch for the given key to be sent.","ref":"Honeylixir.TransmissionQueue.html#process_batch/1","title":"Honeylixir.TransmissionQueue.process_batch/1","type":"function"},{"doc":"","ref":"Honeylixir.TransmissionQueue.html#queue_key/1","title":"Honeylixir.TransmissionQueue.queue_key/1","type":"function"},{"doc":"","ref":"Honeylixir.TransmissionQueue.html#t:t_queue_key/0","title":"Honeylixir.TransmissionQueue.t_queue_key/0","type":"type"},{"doc":"Typically invoked as a Task, handles sending the Honeylixir.Event batches to the Honeylixir.Client and reporting responses from Honeycomb.","ref":"Honeylixir.TransmissionSender.html","title":"Honeylixir.TransmissionSender","type":"module"},{"doc":"Does the actual passoff to the Honeylixir.Client for sending.Responses are sent via :telemetry.execute/3.","ref":"Honeylixir.TransmissionSender.html#send_batch/1","title":"Honeylixir.TransmissionSender.send_batch/1","type":"function"}]